//MQL5 Version  June 21, 2010 Final
//+X================================================================X+
//|                                         IndicatorsAlgorithms.mqh |
//|                               Copyright  2010, Nikolay Kositsin |
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+X================================================================X+
#property copyright "2010,   Nikolay Kositsin"
#property link      "farria@mail.redcom.ru"
#property version   "1.00"

//+X----------------------------------------------------------------X+
//                                          | 
//+X----------------------------------------------------------------X+ 
#include <SmoothAlgorithms.mqh> 
//+X================================================================X+
//|                        |
//+X================================================================X+
class CIndicatorsTools
  {
public:
   int               iBarShift(string symbol,ENUM_TIMEFRAMES timeframe,datetime time);

   bool              bGetLimitX4(
                                 int Number,//     IsNewBar     
                                 //(  - 0   - 3)
                                 string symbol,//   . NULL   .
                                 ENUM_TIMEFRAMES timeframe,// .      . 0    .
                                 bool recount,//        GetLimit()
                                 int &limit //         
                                 );

   bool              IsNewBarX4(int Number,string symbol,ENUM_TIMEFRAMES timeframe);

   int               iHighest(
                              const double &array[],//      
                              int count,//    (        ),
                              //      (  -   !).
                              int startPos // (   )  ,
                              //      
                              );

   int               iLowest(
                             const double &array[],//      
                             int count,//    (        ),
                             //      (  -   !).
                             int startPos // (   )  ,
                             //      
                             );

   int               iHighest_(
                               const double &array[],//      
                               int count,//    (        ),
                               //      (  -    !).
                               int startPos // (   )  ,
                               //      
                               );

   int               iLowest_(
                              const double &array[],//      
                              int count,//    (        ),
                              //      (  -    !).
                              int startPos // (   )  ,
                              //      
                              );

   void              Recount_ArrayZeroPos(int &count,
                                          int Length,
                                          int prev_calculated,
                                          double series,
                                          int bar,
                                          double &Array[]
                                          );

   int               Recount_ArrayNumber(int count,int Length,int Number);

   bool              SeriesArrayResize(string FunctionsName,
                                       int Length,
                                       double &Array[],
                                       int &Size_
                                       );

protected:

   bool              ArrayResizeErrorPrint(
                                           string FunctionsName,
                                           int &Size_
                                           );
                                           
   //----    Moving_Average
   datetime          m_LastTime[4];
   datetime          m_OldLastTime[4];
   datetime          m_Told[4];
  };
//+X================================================================X+
//|  -         |
//+X================================================================X+
class CLRMA
  {
public:
   double LRMASeries(uint begin,//     
                     uint prev_calculated,//       
                     uint rates_total,//       
                     int Length,//  
                     double series,//   ,      bar
                     uint bar,//  
                     bool set //   .
                     )
     {
      //----+
      //----   
      double sma,lwma,lrma;

      //----    Moving_Average   MASeries_Cls.mqh
      // CMoving_Average SMA, LWMA;

      //----     
      sma=m_SMA.SMASeries(begin,prev_calculated,rates_total,Length,series,bar,set);
      lwma=m_LWMA.LWMASeries(begin,prev_calculated,rates_total,Length,series,bar,set);

      //----  LRMA
      lrma=3.0*lwma-2.0*sma;
      //----+
      return(lrma);
     };

protected:
   //----    Moving_Average
   CMoving_Average   m_SMA,m_LWMA;
  };
//+X================================================================X+
//|        VIDYA          |
//+X================================================================X+
class CVidyaBands
  {
public:
   double VidyaBandsSeries(uint begin,//     
                           uint prev_calculated,//       
                           uint rates_total,//       
                           int CMO_period,//    CMO
                           double EMA_period,// EMA  
                           int BBLength,//    
                           double deviation,// 
                           double series,//   ,      bar
                           uint bar,//  
                           bool set,//   
                           double& DnMovSeries,//        
                           double& MovSeries,  //        
                           double &UpMovSeries  //        
                           )
     {
      //----+
      //----+       
      MovSeries=m_VIDYA.VIDYASeries(begin,prev_calculated,rates_total,CMO_period,EMA_period,series,bar,set);

      //----+   
      double StdDev=m_STD.StdDevSeries(begin+CMO_period+1,prev_calculated,rates_total,BBLength,deviation,series,MovSeries,bar,set);
      DnMovSeries = MovSeries - StdDev;
      UpMovSeries = MovSeries + StdDev;
      //----+
      return(StdDev);
     }

protected:
   //----    CCMO  CStdDeviation
   CCMO              m_VIDYA;
   CStdDeviation     m_STD;
  };
//+X================================================================X+
//|                                |
//+X================================================================X+
class CBBands
  {
public:
   double            BBandsSeries(uint begin,//     
                                  uint prev_calculated,//       
                                  uint rates_total,//       
                                  int Length,//  
                                  double deviation,// 
                                  ENUM_MA_METHOD MA_Method,//  
                                  double series,//   ,      bar
                                  uint bar,//  
                                  bool set,//   
                                  double& DnMovSeries,//        
                                  double& MovSeries,  //        
                                  double &UpMovSeries  //        
                                  );

   double            BBandsSeries_(uint begin,//     
                                   uint prev_calculated,//       
                                   uint rates_total,//       
                                   int MALength,//   
                                   ENUM_MA_METHOD MA_Method,//  
                                   int BBLength,//    
                                   double deviation,// 
                                   double series,//   ,      bar
                                   uint bar,//  
                                   bool set,//   
                                   double& DnMovSeries,//        
                                   double& MovSeries,  //        
                                   double &UpMovSeries  //        
                                   );
protected:
   //----    Moving_Average  CStdDeviation
   CStdDeviation     m_STD;
   CMoving_Average   m_MA;
  };
//+X================================================================X+
//|                                       |
//+X================================================================X+    
double CBBands::BBandsSeries
(
 uint begin,//     
 uint prev_calculated,//       
 uint rates_total,//       
 int Length,//  
 double deviation,// 
 ENUM_MA_METHOD MA_Method,// 
 double series,//   ,      bar
 uint bar,//  
 bool set,//   
 double &DnMovSeries,//        
 double &MovSeries,//       
 double &UpMovSeries //       
 )
// BBandsMASeries(begin, prev_calculated, rates_total, period, deviation,
// MA_Method, Series, bar, set, DnMovSeries, MovSeries, UpMovSeries) 
//+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+
  {
//----+
//----+   
   MovSeries=m_MA.MASeries(begin,prev_calculated,rates_total,Length,MA_Method,series,bar,set);

//----+   
   double StdDev=m_STD.StdDevSeries(begin,prev_calculated,rates_total,Length,deviation,series,MovSeries,bar,set);
   DnMovSeries = MovSeries - StdDev;
   UpMovSeries = MovSeries + StdDev;
//----+
   return(StdDev);
  }
//+X================================================================X+
//|                                       |
//+X================================================================X+    
double CBBands::BBandsSeries_
(
 uint begin,//     
 uint prev_calculated,//       
 uint rates_total,//       
 int MALength,//   
 ENUM_MA_METHOD MA_Method,// 
 int BBLength,//    
 double deviation,// 
 double series,//   ,      bar
 uint bar,//  
 bool set,//   
 double &DnMovSeries,//        
 double &MovSeries,//       
 double &UpMovSeries //       
 )
// BBandsMASeries_(begin, prev_calculated, rates_total, MALength, MA_Method,
// deviation, BBLength, Series, bar, set, DnMovSeries, MovSeries, UpMovSeries) 
//+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+
  {
//----+
//----+   
   MovSeries=m_MA.MASeries(begin,prev_calculated,rates_total,MALength,MA_Method,series,bar,set);

//----+   
   double StdDev=m_STD.StdDevSeries(begin+MALength+1,prev_calculated,rates_total,BBLength,deviation,series,MovSeries,bar,set);
   DnMovSeries = MovSeries - StdDev;
   UpMovSeries = MovSeries + StdDev;
//----+
   return(StdDev);
  }
//+X================================================================X+   
//| iBarShift() function                                             |
//+X================================================================X+  
int CIndicatorsTools :: iBarShift(string symbol,ENUM_TIMEFRAMES timeframe,datetime time)

// iBarShift(symbol, timeframe, time)
//+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+
  {
//----+
   if(time<0) return(-1);
   datetime Arr[],time1;

   time1=(datetime)SeriesInfoInteger(symbol,timeframe,SERIES_LASTBAR_DATE);

   if(CopyTime(symbol,timeframe,time,time1,Arr)>0)
     {
      int size=ArraySize(Arr);
      return(size-1);
     }
   else return(-1);
//----+
  }
//+X================================================================X+
//| bGetLimit_X4() function                                          |
//+X================================================================X+
bool CIndicatorsTools :: bGetLimitX4
(
 int Number,//     IsNewBar    
 string symbol,//   . NULL   .
 ENUM_TIMEFRAMES timeframe,// .      . 0    .
 bool recount,//        GetLimit()
 int &limit //
 )
// bGetLimitX4(Number, symbol, timeframe, recount, limit)
//+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+
  {
//----+
   datetime LastTime_;
//----
   if(recount)
     {
      m_LastTime[Number]=m_OldLastTime[Number];
      return(true);
     }

   datetime NewTime=(datetime)SeriesInfoInteger(symbol,timeframe,SERIES_LASTBAR_DATE);

   LastTime_=m_LastTime[Number];

   if(NewTime!=LastTime_)
     {
      if(LastTime_!=0)
         limit=iBarShift(symbol,timeframe,LastTime_);
      else limit=Bars(symbol,timeframe)-1;
      //----
      if(limit<=0) return(false);
      //----
      m_LastTime[Number]=NewTime;
      m_OldLastTime[Number]=LastTime_;
     }
   else limit=0;
//----+
   return(true);
  }
//+X================================================================X+
//| IsNewBar() function                                              |
//+X================================================================X+
bool CIndicatorsTools :: IsNewBarX4
(int Number,string symbol,ENUM_TIMEFRAMES timeframe)
  {
//----+
   datetime Tnew[1];
   CopyTime(symbol,timeframe,0,1,Tnew);
   if(Tnew[0]!=m_Told[Number] && Tnew[0]>0)
     {
      m_Told[Number]=Tnew[0];
      return(true);
     }
//----+
   return(false);
  }
//+------------------------------------------------------------------+
//|                           |
//+------------------------------------------------------------------+
int CIndicatorsTools :: iHighest
(
 const double &array[],//      
 int count,//    (        ),
 //      (  -   !).
 int startPos // (   )  ,
 //      
 )
  {
//----
   int index=startPos;

//----     
   if(startPos<0)
     {
      Print("    iHighest, startPos = ",startPos);
      return(0);
     }

//----   startPos  
   if(count<0) count=startPos;

   double max=array[startPos];

//----  
   for(int i=startPos; i<startPos+count; i++)
     {
      if(array[i]>max)
        {
         index=i;
         max=array[i];
        }
     }
//----    
   return(index);
  }
//+------------------------------------------------------------------+
//|                           |
//+------------------------------------------------------------------+
int CIndicatorsTools :: iLowest
(
 const double &array[],//      
 int count,//    (        ),
 //      (  -   !).
 int startPos // (   )  ,
 //      
 )
  {
//----
   int index=startPos;

//----     
   if(startPos<0)
     {
      Print("    iLowest, startPos = ",startPos);
      return(0);
     }

//----   startPos  
   if(count<0) count=startPos;

   double min=array[startPos];

//----  
   for(int i=startPos; i<startPos+count; i++)
     {
      if(array[i]<min)
        {
         index=i;
         min=array[i];
        }
     }
//----    
   return(index);
  }
//+------------------------------------------------------------------+
//|                           |
//+------------------------------------------------------------------+
int CIndicatorsTools :: iHighest_
(
 const double &array[],//      
 int count,//    (        ),
 //      (  -    !).
 int startPos // (   )  ,
 //      
 )
  {
//----
   int index=startPos;

//----     
   if(startPos<0)
     {
      Print("    iHighest, startPos = ",startPos);
      return(0);
     }

//----   startPos  
   if(startPos-count<0) count=startPos;

   double max=array[startPos];

//----  
   for(int i=startPos; i>startPos-count; i--)
     {
      if(array[i]>max)
        {
         index=i;
         max=array[i];
        }
     }
//----    
   return(index);
  }
//+------------------------------------------------------------------+
//|                           |
//+------------------------------------------------------------------+
int CIndicatorsTools :: iLowest_
(
 const double &array[],//      
 int count,//    (        ),
 //      (  -    !).
 int startPos // (   )  ,
 //      
 )
  {
//----
   int index=startPos;

//----     
   if(startPos<0)
     {
      Print("    iLowest, startPos = ",startPos);
      return(0);
     }

//----   startPos  
   if(startPos-count<0)
      count=startPos;

   double min=array[startPos];

//----  
   for(int i=startPos; i>startPos-count; i--)
     {
      if(array[i]<min)
        {
         index=i;
         min=array[i];
        }
     }
//----    
   return(index);
  }
//+X================================================================X+
//|                       |
//+X================================================================X+    
void CIndicatorsTools :: Recount_ArrayZeroPos
(
 int &count,//        
 int Size,//  
 int prev_calculated,
 double series,//   ,      bar
 int bar,
 double &Array[]
 )
// Recount_ArrayZeroPos(count, Size, prev_calculated, series, bar, Array[])
//+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+
  {
//----+
   if(bar!=prev_calculated-1)
     {
      count--;
      if(count<0) count=Size-1;
     }

   Array[count]=series;
//----+
  }
//+X================================================================X+
//|                     |
//+X================================================================X+    
int CIndicatorsTools :: Recount_ArrayNumber
(
 int count,//     
 int Size,//  
 int Number //       bar
 )
// Recount_ArrayNumber(count, Size, Number)
//+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+
  {
//----+
   int ArrNumber=Number+count;

   if(ArrNumber>Size-1) ArrNumber-=Size;
//----+
   return(ArrNumber);
  }
//+X================================================================X+
//|     Array[]                               |
//+X================================================================X+    
bool CIndicatorsTools :: SeriesArrayResize
(
 string FunctionsName,//  ,    
 int Size,//   
 double &Array[],//  
 int &Size_ //   
 )
// SeriesArrayResize(FunctionsName, Size, Array, Size_) 
//+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+
  {
//----+    

//----+    
   if(Size>Size_)
     {
      int size=Size+1;

      if(ArrayResize(Array,size)==-1)
        {
         ArrayResizeErrorPrint(FunctionsName,Size_);
         return(false);
        }

      Size_=size;
     }
//----+
   return(true);
  }
//+X================================================================X+
//|                        |
//+X================================================================X+    
bool CIndicatorsTools :: ArrayResizeErrorPrint
(
 string FunctionsName,
 int &Size_
 )
// ArrayResizeErrorPrint(FunctionsName, Size_) 
//+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+
  {
//----+    
   string lable,word;
   StringConcatenate(lable,FunctionsName,"():");
   StringConcatenate(word,lable," !!!   ",
                     "     ",FunctionsName,"()!");
   Print(word);
//----             
   int error=GetLastError();
   ResetLastError();
//----
   if(error>4000)
     {
      StringConcatenate(word,lable,"():   ",error);
      Print(word);
     }

   Size_=-2;
   return(false);
//----+
   return(true);
  }
//+X----------------------+ <<< The End >>> +-----------------------X+
